Y.namespace("u1");

var AppPromo = Y.Base.create('app-promo', Y.Base, [], {
    render: function(message, locationUrl) {
        if (!Y.Cookie.get(this.get("cookie_name"))) {
            var result = window.confirm(message);
            return (result === true) ? this.onOk(locationUrl) : this.onCancel();
        }
    },
    onOk: function(locationUrl) {
        this.setCookie();
        window.location = locationUrl;
    },
    onCancel: function() {
        this.setCookie();
    },
    getDatePlusNDays: function(nDays) {
        var current = new Date();
        current.setDate(current.getDate()+nDays);
        return current;
    },
    setCookie: function() {
        var expires = this.getDatePlusNDays(this.get("cookie_life_days"));
        Y.Cookie.set(this.get("cookie_name"), 1, {
            path: this.get("cookie_path"),
            expires: expires
        });
    }
}, {
    ATTRS: {
        cookie_name: { value: null },
        cookie_life_days: { value: 30 },
        cookie_domain: {  value: null },
        cookie_path: { value: "/" }
    }
});
Y.u1.AppPromo = AppPromo;
