YUI.add('one-music-widgets-test', function (Y) {

var suite,

    setupTemplate = function () {

        // creates template in which our created music widgets will live and die
        Y.one('.container').append(Y.Node.create(Y.Template.Micro.render(Y.one('#template').getContent(), {})));
    },

    tearDownTemplate = function () {
        Y.one('.container').get('childNodes').remove().destroy();
    },

    widgetConfig = {
        srcNode:        '.srcNode',
        contentBox:     '.contentBox'
    };

suite = new Y.Test.Suite('one-music-widgets');

suite.add(new Y.Test.Case({

    name: 'All',

    setUp: function () {

        setupTemplate();

        this.subMenu = new Y.Music.SubMenu(widgetConfig);
        this.slider = new Y.Music.Slider(widgetConfig);
        this.dialog = new Y.Music.Dialog(widgetConfig);
    },

    tearDown: function () {
        tearDownTemplate();

        this.subMenu.destroy();
        this.slider.destroy();
        this.dialog.destroy();
    },


    "instantiated subMenu ok": function () {
        Y.Assert.isInstanceOf(Y.Music.SubMenu, this.subMenu);
    },

    "instantiated slider ok": function () {
        Y.Assert.isInstanceOf(Y.Music.Slider, this.slider);
    },

    "instantiated dialog ok": function () {
        Y.Assert.isInstanceOf(Y.Music.Dialog, this.dialog);
    }

}));


Y.Test.Runner.add(suite);

}, '@VERSION@', {
        requires: ['one-music-widgets', 'template']
});
