/*

    This view represent invokes the gallery-app

*/
var GALLERYACTIVE = 'gallery-active',
    AlbumGalleryView;

AlbumGalleryView = Y.Base.create('albumGalleryView', Y.View, [], {

    template: Y.one('#gallery-template').getContent(),

    spawnedGallery: null,

    render: function (photo, config) {
        var content = this.cont || Y.one('#cont'),
            originalScrollPosition = Y.one('window').get('scrollTop'),
            galleryNode = Y.Node.create(
                Y.substitute(
                    this.template,
                    {
                        photo: photo,
                        album_url: config.albumURL
                    },
                    function(k,v){ return Y.Escape.html(v); }
                )
            ),
            gallery;


        // make them available later
        this.cont = content;
        this.galleryNode = galleryNode;

        content.insert(galleryNode, 'after');

        gallery = new Y.Photos.GalleryApp(config);
        this.spawnedGallery = gallery;

        gallery.once('galleryPhoto:idle', function () {
            galleryNode.all('.pending-fadein').transition({
                opacity: 1,
                duration: 1
            }, function () {
                this.removeClass('pending-fadein');
            });
        });

        content.addClass(GALLERYACTIVE);

        gallery.fire('one:busy');

        // when gallery is closed
        gallery.after('destroy', this.afterGalleryDestroy, this, originalScrollPosition);
    },

    afterGalleryDestroy: function(e, originalScrollPosition) {
        this.cont.removeClass(GALLERYACTIVE);

        // fade out and remove galleryNode
        this.galleryNode.transition({

            duration: 0.3,
            opacity: 0

        }, function() {

            // galleryNode is in a app-views thing, so remove parent
            this.get('parentNode').remove();

        });
        this.spawnedGallery = null;
        this.galleryNode = null;

        // scroll to original position
        Y.one(Y.config.win).set('scrollTop', originalScrollPosition);
    }

});

Y.namespace('Photos').AlbumGalleryView  = AlbumGalleryView;

