YUI.add('one-photos-album-app-test', function (Y) {

var Assert = Y.Assert,
    suite,
    html5 = Y.Router.html5,
    win = Y.config.win,
    originalURL = (win && win.location.toString()) || '',
    resetURL = function () {
        if (html5) {
            win && win.history.replaceState(null, null, originalURL);
        } else {
            win && (win.location.hash = '');
        }
    };

suite = new Y.Test.Suite('Photos Album');

suite.add(new Y.Test.Case({

    name: 'AlbumAppTests',

    setUp : function () {

        resetURL();

        // create app, but no routing
        this.app = new Y.Photos.AlbumApp({
            photoList: new Y.Photos.PhotoList({
                items: Y.Photos.TestData.photos,
                path: Y.Photos.TestData.path
            }),
            albumURLScheme: '',
            galleryURLScheme: ''
        });

        Y.Photos.TestData.resetPhotoList(this.app.get('photoList'));

    },

    tearDown: function () {
        this.app && this.app.destroy({remove: true});
        resetURL();
    },

    "use ok": function () {
        Assert.isTrue(!!this.app);
    }



}));


Y.Test.Runner.add(suite);

}, '@VERSION@', {
        requires: ['one-photos-album-app', 'one-photos-test-shared', 'test']
});
