YUI.add('plugin-panel-anim-test', function (Y) {

var Assert = Y.Assert,
    suite;

suite = new Y.Test.Suite('Plugin: Panel-Anim');

suite.add(new Y.Test.Case({

    name: '',

    setUp : function () {
        this.panel = new Y.Panel({
            srcNode: '#test',
            modal: true,
            visible: false,
            render: true
        });

        this.panel.plug(Y.U1Plugin.PanelAnim);
    },

    tearDown: function () {
        this.panel && this.panel.destroy();
        delete this.panel;
        Y.one('#test').empty();
    },

    "PluginAnimPanel should animate the opacity of the Panel mask": function() {
        var node = this.panel._getMaskNode().getDOMNode();
        Assert.isNotNull(Y.one('.yui3-widget-mask'), 'No widget mask node.');
        this.panel.show();
        /**
         * this tests the opacity as set by the plugin, but not the actual
         * transition used, which is governed by Y.Transition
         * TODO get attrs from plugin for opacity and duration of transition
         */

        this.wait(function() {
        Assert.areEqual(0.3, node.style.opacity, "Opacity should be 0.3");
        }, 400); // 100ms after transition has complete
    }

}));

Y.Test.Runner.add(suite);

}, '@VERSION@', {
        requires: ['panel', 'one-plugin-panel-anim', 'test']
});
