/*global external */
    var init_callbacks = [],
    ns = Y.namespace("Unity");

ns.ready = false;

function unityReady() {
    ns.ready = true;
    init_callbacks.reverse();
    while (init_callbacks.length > 0) {
        var callback = init_callbacks.pop();
        callback();
    }
}

/* Initialise Unity Webapps integration.  Should only be called once. */
ns.init = function init(parameters) {
    if (typeof external !== "undefined" && external && external.getUnityObject) {
        var Unity = external.getUnityObject(1.0);
        ns.Unity = Unity;
        if (parameters.onInit) {
            ns.onInit(parameters.onInit);
        }
        parameters.onInit = unityReady;
        Unity.init(parameters);
    }
};

/* Add a callback that will be fired when Unity Webapps
 * integration is enabled.  If integration has already been
 * enabled, then the callback will be run immediately. */
ns.onInit = function onInit(callback) {
    if (ns.ready) {
        callback();
    } else {
        init_callbacks.push(callback);
    }
};
