Y.namespace("U1.util");

// TODO web intents?

var Share = function(link, photo) {

    this.photo = photo;
    this.link = link;

};

Share.prototype = {

    getUrl: function() {
        if (this.url && this.url.length) {
            return this.url;
        } else {
            throw new Error("must set a url type before get");
        }
    },

    setUrl: function(type) {
        switch (type) {
            case 'facebook':
                this.url = this._facebookUrl(this.link, this.photo);
            break;
            case 'twitter':
                this.url = this._twitterUrl(this.link);
            break;
            default:
        }

        return this;

    },

    /**
     * Opens a window to share the link
     */
    open: function(w, h, name) {
        name = name || "U1Share";
        var url = this.getUrl(),
            conf = this.getConfString(w, h),
            u1Window;
        u1Window = Y.config.win.open(url, name, conf);
    },

    /**
     * Generated a conf string from width and height
        @method generateConfString
        @param {Number} w the window width (defaults to 420)
        @param {Number} h the window height (defaults to 480)
     */
    getConfString: function(w, h) {
        w = w || 420;
        h = h || 480;
        var win = Y.config.win,
            left_ = parseInt((win.screen.width/2)-(w/2), 10),
            top_ = parseInt((win.screen.height/2)-(h/2), 10);
        return "width="+w+",height="+h+",left="+left_+",top="+top_+",status=yes";
    },

    _facebookUrl: function(link, photo) {
        var url = "http://www.facebook.com/dialog/feed?",
            id = "166704313352575",
            display = "popup",
            redirect = "https://one.ubuntu.com/window-close/";

        if (link && link.length) {

            url += ["app_id=" + id,
                "link="+ window.encodeURI(link),
                "redirect_uri="+ window.encodeURI(redirect),
                "display="+ display
            ].join('&');

            if (photo && photo.length) {
                url += "&picture="+ window.encodeURI(photo);
            }

            return url;

        } else {
            throw new Error("_createFacebookUrl requires link to share");
        }
    },

    _twitterUrl: function(link) {
        var url = "https://twitter.com/share?";

        if (link && link.length) {

            url += [
                "url="+ window.encodeURI(link),
                "text="+ window.encodeURI("Sharing a link from UbuntuOne."),
                "hashtags=ubuntuone"
            ].join('&');


            return url;

        } else {
            throw new Error("createTwitterUrl requires link to share");
        }
    }

};

Y.U1.util.Share = Share;
