YUI.add('util-test', function (Y) {

var Assert = Y.Assert,
    suite;

suite = new Y.Test.Suite('Util');

suite.add(new Y.Test.Case({

    name: 'Utils: Share Tests',

    setUp : function () {
        this.data = {
            photo: "http://example.com/photo.jpg",
            link: "http://example.com/path/to/resource"
        };
    },

    tearDown: function () {
        delete this.data;
    },

    // TODO get the config strings from the constructor, not derp printing it like this
    "testShouldBeCorrectFacebookUrl": function() {
        var d = this.data,
                link;

        link = new Y.U1.util.Share(d.link, d.photo);

        link.setUrl('facebook');


        Assert.areEqual("http://www.facebook.com/dialog/feed?app_id=166704313352575&link=" +
                        d.link +
                        "&redirect_uri=https://one.ubuntu.com/window-close/&display=popup" +
                        "&picture=" +
                        d.photo,
                        link.getUrl(), "url is wrong");

    },

    // eg. photo albums
    "testShouldBeCorrectFacebookUrlNoPicture": function() {
        var d = this.data,
                link;

        link = new Y.U1.util.Share(d.link);

        link.setUrl('facebook');
        Assert.areEqual("http://www.facebook.com/dialog/feed?app_id=166704313352575&link=" +
                        d.link +
                        "&redirect_uri=https://one.ubuntu.com/window-close/&display=popup",
                        link.getUrl(), "url is wrong");

    },
    // TODO get the config strings from the constructor, not derp printing it like this
    "testshouldReturnCorrectTwitterURL": function() {
        var d = this.data,
                link;

        link = new Y.U1.util.Share(d.link);

        link.setUrl('twitter');

        Assert.areEqual("https://twitter.com/share?url=" +
                        d.link +
                        "&text=Sharing%20a%20link%20from%20UbuntuOne.&hashtags=ubuntuone", link.getUrl(), "url is wrong");
    }

}));

Y.Test.Runner.add(suite);

}, '@VERSION@', {
        requires: ['one-util-share', 'test']
});
